<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>Advanced Cuts for Cooperative OPF: decoop::DynArrayRAIIWrapper&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Advanced Cuts for Cooperative OPF
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Friends</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedecoop.html">decoop</a></li><li class="navelem"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">decoop::DynArrayRAIIWrapper&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Templated wrapper class to provide iterators and element access to a dynamic array, as well as simpler memory management.  
 <a href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="dyn_array_raii_wrapper_8hpp_source.html">dynArrayRaiiWrapper.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a2867fd822f4f2816f57951a8aaf6d020"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2867fd822f4f2816f57951a8aaf6d020"></a>
using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020">iterator</a> = T *</td></tr>
<tr class="memdesc:a2867fd822f4f2816f57951a8aaf6d020"><td class="mdescLeft">&#160;</td><td class="mdescRight">Define iterator. <br/></td></tr>
<tr class="separator:a2867fd822f4f2816f57951a8aaf6d020"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a954de3f65f5ea2e6eccc4c8aa3726456"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a954de3f65f5ea2e6eccc4c8aa3726456"></a>
using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a> = const T *</td></tr>
<tr class="memdesc:a954de3f65f5ea2e6eccc4c8aa3726456"><td class="mdescLeft">&#160;</td><td class="mdescRight">Define const_iterator. <br/></td></tr>
<tr class="separator:a954de3f65f5ea2e6eccc4c8aa3726456"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aae505d86823ce970f0347b8e66f732e3"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#aae505d86823ce970f0347b8e66f732e3">DynArrayRAIIWrapper</a> (T *dyn_arr, size_t <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a934da971890063138fbefe63bee73eb2">size</a>)</td></tr>
<tr class="memdesc:aae505d86823ce970f0347b8e66f732e3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#aae505d86823ce970f0347b8e66f732e3">More...</a><br/></td></tr>
<tr class="separator:aae505d86823ce970f0347b8e66f732e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00c52a28bfbf3aac0ac786aae78934d2"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a00c52a28bfbf3aac0ac786aae78934d2"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a00c52a28bfbf3aac0ac786aae78934d2">~DynArrayRAIIWrapper</a> ()=default</td></tr>
<tr class="memdesc:a00c52a28bfbf3aac0ac786aae78934d2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default destructor. <br/></td></tr>
<tr class="separator:a00c52a28bfbf3aac0ac786aae78934d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a214fbc6a27b5836f891be58108ff126d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a214fbc6a27b5836f891be58108ff126d"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a214fbc6a27b5836f891be58108ff126d">DynArrayRAIIWrapper</a> (<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a> const &amp;other)=delete</td></tr>
<tr class="memdesc:a214fbc6a27b5836f891be58108ff126d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy constructor is deleted. <br/></td></tr>
<tr class="separator:a214fbc6a27b5836f891be58108ff126d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af5c0dac5d642405e58983c5e2f27d602"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af5c0dac5d642405e58983c5e2f27d602"></a>
<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#af5c0dac5d642405e58983c5e2f27d602">operator=</a> (<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a> const &amp;other)=delete</td></tr>
<tr class="memdesc:af5c0dac5d642405e58983c5e2f27d602"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy assignment operator is deleted. <br/></td></tr>
<tr class="separator:af5c0dac5d642405e58983c5e2f27d602"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada83e78b7f8fa48f67929fcd3b69bbd3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ada83e78b7f8fa48f67929fcd3b69bbd3"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#ada83e78b7f8fa48f67929fcd3b69bbd3">DynArrayRAIIWrapper</a> (<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a> &amp;&amp;other)=default</td></tr>
<tr class="memdesc:ada83e78b7f8fa48f67929fcd3b69bbd3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default move constructor. <br/></td></tr>
<tr class="separator:ada83e78b7f8fa48f67929fcd3b69bbd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e329add0492981cab4e32dfae6fd82a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8e329add0492981cab4e32dfae6fd82a"></a>
<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a8e329add0492981cab4e32dfae6fd82a">operator=</a> (<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a> &amp;&amp;other)=default</td></tr>
<tr class="memdesc:a8e329add0492981cab4e32dfae6fd82a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default move assignment operator. <br/></td></tr>
<tr class="separator:a8e329add0492981cab4e32dfae6fd82a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a934da971890063138fbefe63bee73eb2"><td class="memItemLeft" align="right" valign="top">size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a934da971890063138fbefe63bee73eb2">size</a> () const noexcept</td></tr>
<tr class="memdesc:a934da971890063138fbefe63bee73eb2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns number of elements of the wrapped array.  <a href="#a934da971890063138fbefe63bee73eb2">More...</a><br/></td></tr>
<tr class="separator:a934da971890063138fbefe63bee73eb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70bc743139d8f34a00e5fda82814029e"><td class="memItemLeft" align="right" valign="top">T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a70bc743139d8f34a00e5fda82814029e">operator[]</a> (size_t index) noexcept</td></tr>
<tr class="memdesc:a70bc743139d8f34a00e5fda82814029e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Element access operator by index.  <a href="#a70bc743139d8f34a00e5fda82814029e">More...</a><br/></td></tr>
<tr class="separator:a70bc743139d8f34a00e5fda82814029e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab67f010a86a8cf5428be4d9669a2145a"><td class="memItemLeft" align="right" valign="top">const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#ab67f010a86a8cf5428be4d9669a2145a">operator[]</a> (size_t index) const noexcept</td></tr>
<tr class="memdesc:ab67f010a86a8cf5428be4d9669a2145a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constant element access operator by index.  <a href="#ab67f010a86a8cf5428be4d9669a2145a">More...</a><br/></td></tr>
<tr class="separator:ab67f010a86a8cf5428be4d9669a2145a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b2bc4f10c2521d9963ca475d9bac82b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020">iterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a6b2bc4f10c2521d9963ca475d9bac82b">begin</a> () noexcept</td></tr>
<tr class="memdesc:a6b2bc4f10c2521d9963ca475d9bac82b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020" title="Define iterator. ">iterator</a> to the beginning of the array.  <a href="#a6b2bc4f10c2521d9963ca475d9bac82b">More...</a><br/></td></tr>
<tr class="separator:a6b2bc4f10c2521d9963ca475d9bac82b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8616fa6972ed3e748d00b7baab58de9"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#af8616fa6972ed3e748d00b7baab58de9">begin</a> () const noexcept</td></tr>
<tr class="memdesc:af8616fa6972ed3e748d00b7baab58de9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the beginning of the array.  <a href="#af8616fa6972ed3e748d00b7baab58de9">More...</a><br/></td></tr>
<tr class="separator:af8616fa6972ed3e748d00b7baab58de9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6aab66a92c59b017fd6fd72f8ef1e55c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a6aab66a92c59b017fd6fd72f8ef1e55c">cbegin</a> () const noexcept</td></tr>
<tr class="memdesc:a6aab66a92c59b017fd6fd72f8ef1e55c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the beginning of the array.  <a href="#a6aab66a92c59b017fd6fd72f8ef1e55c">More...</a><br/></td></tr>
<tr class="separator:a6aab66a92c59b017fd6fd72f8ef1e55c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a170440e3e195b645c882a6407cf3ba4e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020">iterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a170440e3e195b645c882a6407cf3ba4e">end</a> () noexcept</td></tr>
<tr class="memdesc:a170440e3e195b645c882a6407cf3ba4e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns an <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020" title="Define iterator. ">iterator</a> to the element following the last element of the array. Accessing it results in undefined behaviour.  <a href="#a170440e3e195b645c882a6407cf3ba4e">More...</a><br/></td></tr>
<tr class="separator:a170440e3e195b645c882a6407cf3ba4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a1713bd17ebd94657667b2e8520451a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a1a1713bd17ebd94657667b2e8520451a">end</a> () const noexcept</td></tr>
<tr class="memdesc:a1a1713bd17ebd94657667b2e8520451a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the element following the last element of the array. Accessing it results in undefined behaviour.  <a href="#a1a1713bd17ebd94657667b2e8520451a">More...</a><br/></td></tr>
<tr class="separator:a1a1713bd17ebd94657667b2e8520451a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab566b2fade2c9b673713b647909d7e5d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#ab566b2fade2c9b673713b647909d7e5d">cend</a> () const noexcept</td></tr>
<tr class="memdesc:ab566b2fade2c9b673713b647909d7e5d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the element following the last element of the array. Accessing it results in undefined behaviour.  <a href="#ab566b2fade2c9b673713b647909d7e5d">More...</a><br/></td></tr>
<tr class="separator:ab566b2fade2c9b673713b647909d7e5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a72c5952d647f1b5e93f207ee2deaca8e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a72c5952d647f1b5e93f207ee2deaca8e"></a>
std::unique_ptr&lt; T[]&gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a72c5952d647f1b5e93f207ee2deaca8e">begin_</a></td></tr>
<tr class="memdesc:a72c5952d647f1b5e93f207ee2deaca8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Smart pointer to the beginning of the array. Handles memory management. <br/></td></tr>
<tr class="separator:a72c5952d647f1b5e93f207ee2deaca8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8dc6bf33800567ee955bb95546db8fd1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8dc6bf33800567ee955bb95546db8fd1"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a8dc6bf33800567ee955bb95546db8fd1">end_</a></td></tr>
<tr class="memdesc:a8dc6bf33800567ee955bb95546db8fd1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the element following the last element of the array. <br/></td></tr>
<tr class="separator:a8dc6bf33800567ee955bb95546db8fd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br/>
class decoop::DynArrayRAIIWrapper&lt; T &gt;</h3>

<p>Templated wrapper class to provide iterators and element access to a dynamic array, as well as simpler memory management. </p>
<dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>Type of the elements in the dynamic array to be wrapped. </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aae505d86823ce970f0347b8e66f732e3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a> </td>
          <td>(</td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>dyn_arr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dyn_arr</td><td>The dynamic array to be wrapped. </td></tr>
    <tr><td class="paramname">size</td><td>Number of elements in the dynamic array. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a6b2bc4f10c2521d9963ca475d9bac82b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; T &gt;::<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020">iterator</a> <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::begin </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns an <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020" title="Define iterator. ">iterator</a> to the beginning of the array. </p>
<dl class="section return"><dt>Returns</dt><dd>Iterator to first element. </dd></dl>

</div>
</div>
<a class="anchor" id="af8616fa6972ed3e748d00b7baab58de9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; T &gt;::<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a> <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::begin </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the beginning of the array. </p>
<dl class="section return"><dt>Returns</dt><dd>Iterator to constant first element. </dd></dl>

</div>
</div>
<a class="anchor" id="a6aab66a92c59b017fd6fd72f8ef1e55c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; T &gt;::<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a> <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::cbegin </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the beginning of the array. </p>
<dl class="section return"><dt>Returns</dt><dd>Iterator to constant first element. </dd></dl>

</div>
</div>
<a class="anchor" id="ab566b2fade2c9b673713b647909d7e5d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; T &gt;::<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a> <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::cend </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the element following the last element of the array. Accessing it results in undefined behaviour. </p>
<dl class="section return"><dt>Returns</dt><dd>Iterator to element following the last element. </dd></dl>

</div>
</div>
<a class="anchor" id="a170440e3e195b645c882a6407cf3ba4e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; T &gt;::<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020">iterator</a> <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::end </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns an <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a2867fd822f4f2816f57951a8aaf6d020" title="Define iterator. ">iterator</a> to the element following the last element of the array. Accessing it results in undefined behaviour. </p>
<dl class="section return"><dt>Returns</dt><dd>Iterator to element following the last element. </dd></dl>

</div>
</div>
<a class="anchor" id="a1a1713bd17ebd94657667b2e8520451a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">DynArrayRAIIWrapper</a>&lt; T &gt;::<a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456">const_iterator</a> <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::end </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html#a954de3f65f5ea2e6eccc4c8aa3726456" title="Define const_iterator. ">const_iterator</a> to the element following the last element of the array. Accessing it results in undefined behaviour. </p>
<dl class="section return"><dt>Returns</dt><dd>Iterator to element following the last element. </dd></dl>

</div>
</div>
<a class="anchor" id="a70bc743139d8f34a00e5fda82814029e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">T &amp; <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::operator[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Element access operator by index. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>Index to be accessed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Reference to element at specified index. </dd></dl>

</div>
</div>
<a class="anchor" id="ab67f010a86a8cf5428be4d9669a2145a"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const T &amp; <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::operator[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constant element access operator by index. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>Index to be accessed. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Reference to constant element at specified index. </dd></dl>

</div>
</div>
<a class="anchor" id="a934da971890063138fbefe63bee73eb2"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classdecoop_1_1_dyn_array_r_a_i_i_wrapper.html">decoop::DynArrayRAIIWrapper</a>&lt; T &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns number of elements of the wrapped array. </p>
<dl class="section return"><dt>Returns</dt><dd>Number of elements of the wrapped array. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>inc/<a class="el" href="dyn_array_raii_wrapper_8hpp_source.html">dynArrayRaiiWrapper.hpp</a></li>
<li>src/<a class="el" href="dyn_array_raii_wrapper_8cpp.html">dynArrayRaiiWrapper.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
